﻿package {
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import funnel.*;
	import funnel.i2c.*;

	/**
	* @author Kakeru Sakamoto
	*/
	
	public class Main extends Sprite {
		private var fio:Fio;
		
		private var accl:LIS302DL;
		
		private var cx:Number;
		private var cy:Number;
		private var cz:Number;
		private var px:Number;
		private var py:Number;
		private var pz:Number;
		
		private var key:String = "";
		private var a:Number = 0;
		
		public function Main() {
			trace("start");
			init();
			addEvents();
		}
		
		private function init():void
		{
			var config:Configuration = Fio.FIRMATA;
			config.setDigitalPinMode(12, IN);
			config.setDigitalPinMode(13, OUT);
			
			// set unused analog pins to digital outputs to save processor time
			config.setDigitalPinMode(15, OUT);	// set A1 as digital output
			config.setDigitalPinMode(16, OUT);	// set A2 as digital output
			config.setDigitalPinMode(17, OUT);	// set A3 as digital output		
			config.setDigitalPinMode(20, OUT);	// set A6 as digital output		
			config.setDigitalPinMode(21, OUT);	// set A7 as digital output	

			fio = new Fio([1], config);
			
			accl = new LIS302DL(fio.ioModule(1));
			
			anim.gotoAndStop(1);
		}
		
		private function addEvents():void
		{
			fio.addEventListener(FunnelEvent.READY, trace);
			fio.addEventListener(FunnelErrorEvent.REBOOT_ERROR, trace);
			fio.addEventListener(FunnelErrorEvent.CONFIGURATION_ERROR, trace);
			fio.addEventListener(FunnelErrorEvent.ERROR, trace);
			
			// ループ
			this.addEventListener(Event.ENTER_FRAME, enterFrame);
			
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDown);
			stage.addEventListener(KeyboardEvent.KEY_UP, keyUp);
		}
		
		private function enterFrame(e:Event):void 
		{	
			FunnelMode();
			//KeyTestMode();
			
		}
		
		private function keyDown(e:KeyboardEvent){
			//trace(e.keyCode);
			switch(e.keyCode) {
				case 37:
					key = "LEFT";
					break;
				case 38:
					key = "UP";
					break;
				case 39:
					key = "RIGHT";
					break;
				case 40:
					key = "DOWN";
					break;
				default:
					break;
			}
		}
		
		private function keyUp(e:KeyboardEvent){
			key = "";
		}
		
		private function FunnelMode():void {
			
			cx = accl.x;
			cy = accl.y;
			cz = accl.z;
			
			//trace(cy.toFixed(3));
			if (cy < -0.20) {
				if (a <= 10) a += 1;
				
				anim.x += a;
				
				if (anim.rotation <= 30) {
					anim.rotation += (a*0.1);
				}
				
			} else if (cy > 0.20) {
				if (a <= 10) a += 1;
				
				anim.x -= a;
				
				if (anim.rotation >= -30) {
					anim.rotation -= (a*0.1);
				}	
			} else {
				a = 0;
				
				if (anim.rotation > 1) { 
					anim.rotation -= 2;
				} else if (anim.rotation < -1) {
					anim.rotation += 2;
				} else {
					anim.rotation = 0;
				}
			}
			
			if (cx < -0.20) {
				//anim.y -= 5;
				anim.gotoAndStop(3);
			} else if (cx > 0.20) {
				//anim.y += 5;
				anim.gotoAndStop(2);		
			} else {
				anim.gotoAndStop(1);
			}
			
			px = cx;
			py = cy;
			pz = cz;
		}
		
		private function KeyTestMode():void {
			//trace(key);
			if (key == "RIGHT") {
				if (a <= 10) a += 1;
				
				anim.x += a;
				
				if (anim.rotation <= 30) {
					anim.rotation += (a*0.1);
				}
			
			} else if (key == "LEFT") {
				if (a <= 10) a += 1;
				
				anim.x -= a;
				
				if (anim.rotation >= -30) {
					anim.rotation -= (a*0.1);
				}
				
			} else {
				a = 0;
				
				if (anim.rotation > 1) { 
					anim.rotation -= 2;
				} else if (anim.rotation < -1) {
					anim.rotation += 2;
				} else {
					anim.rotation = 0;
				}
			}
			
			if (key == "DOWN") {
				//anim.y -= 5;
				anim.gotoAndStop(3);
			} else if (key == "UP") {
				//anim.y += 5;
				anim.gotoAndStop(2);		
			} else {
				anim.gotoAndStop(1);
			}
		}
	}
}