﻿package funnel{
	import funnel.IOModule;

	/**
	 * This is the class to handle FirmataString messages
	 *
	 */
	public class FirmataString implements ISysexMessageListener {

		protected var _io:IOModule;

		public function FirmataString(ioModule:*) {
			if (ioModule is IOModule) {
				_io = ioModule;
			} else if (ioModule is IOSystem) {
				_io = ioModule.ioModule(0);
			} else {
				throw new ArgumentError("the first argument should be an IOModule or a IOSystem");
				return;
			}

			_io.addSysexListener(this);
		}

		/**
		 * @inheritDoc
		 */
		public function handleSysex(command:uint, data:Array):void {
			trace("Firmata String (from " + _io.id + "): " + data[0]);
		}

		/**
		 * @inheritDoc
		 */
		public function get command():uint {
			return IOModule.FIRMATA_STRING;
		}
	}
}